{
  "address": "0x09E040a72FD3492355C5aEEdbC3154075f83488a",
  "abi": [
    {
      "inputs": [],
      "stateMutability": "nonpayable",
      "type": "constructor"
    },
    {
      "anonymous": false,
      "inputs": [
        {
          "indexed": false,
          "internalType": "uint8",
          "name": "version",
          "type": "uint8"
        }
      ],
      "name": "Initialized",
      "type": "event"
    },
    {
      "anonymous": false,
      "inputs": [
        {
          "indexed": true,
          "internalType": "address",
          "name": "previousOwner",
          "type": "address"
        },
        {
          "indexed": true,
          "internalType": "address",
          "name": "newOwner",
          "type": "address"
        }
      ],
      "name": "OwnershipTransferred",
      "type": "event"
    },
    {
      "inputs": [],
      "name": "EXIT_1_NO_RETURN_STEP",
      "outputs": [
        {
          "internalType": "uint8",
          "name": "",
          "type": "uint8"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "PROXY_TRANSFER_STEP",
      "outputs": [
        {
          "internalType": "uint8",
          "name": "",
          "type": "uint8"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "config",
      "outputs": [
        {
          "components": [
            {
              "internalType": "contract AddressManager",
              "name": "addressManager",
              "type": "address"
            },
            {
              "internalType": "contract ProxyAdmin",
              "name": "proxyAdmin",
              "type": "address"
            },
            {
              "internalType": "address",
              "name": "controller",
              "type": "address"
            },
            {
              "internalType": "address",
              "name": "finalOwner",
              "type": "address"
            }
          ],
          "internalType": "struct SystemDictator.GlobalConfig",
          "name": "globalConfig",
          "type": "tuple"
        },
        {
          "components": [
            {
              "internalType": "address",
              "name": "l2OutputOracleProxy",
              "type": "address"
            },
            {
              "internalType": "address",
              "name": "optimismPortalProxy",
              "type": "address"
            },
            {
              "internalType": "address",
              "name": "l1CrossDomainMessengerProxy",
              "type": "address"
            },
            {
              "internalType": "address",
              "name": "l1StandardBridgeProxy",
              "type": "address"
            },
            {
              "internalType": "address",
              "name": "optimismMintableERC20FactoryProxy",
              "type": "address"
            },
            {
              "internalType": "address",
              "name": "l1ERC721BridgeProxy",
              "type": "address"
            },
            {
              "internalType": "address",
              "name": "systemConfigProxy",
              "type": "address"
            }
          ],
          "internalType": "struct SystemDictator.ProxyAddressConfig",
          "name": "proxyAddressConfig",
          "type": "tuple"
        },
        {
          "components": [
            {
              "internalType": "contract L2OutputOracle",
              "name": "l2OutputOracleImpl",
              "type": "address"
            },
            {
              "internalType": "contract OptimismPortal",
              "name": "optimismPortalImpl",
              "type": "address"
            },
            {
              "internalType": "contract L1CrossDomainMessenger",
              "name": "l1CrossDomainMessengerImpl",
              "type": "address"
            },
            {
              "internalType": "contract L1StandardBridge",
              "name": "l1StandardBridgeImpl",
              "type": "address"
            },
            {
              "internalType": "contract OptimismMintableERC20Factory",
              "name": "optimismMintableERC20FactoryImpl",
              "type": "address"
            },
            {
              "internalType": "contract L1ERC721Bridge",
              "name": "l1ERC721BridgeImpl",
              "type": "address"
            },
            {
              "internalType": "contract PortalSender",
              "name": "portalSenderImpl",
              "type": "address"
            },
            {
              "internalType": "contract SystemConfig",
              "name": "systemConfigImpl",
              "type": "address"
            }
          ],
          "internalType": "struct SystemDictator.ImplementationAddressConfig",
          "name": "implementationAddressConfig",
          "type": "tuple"
        },
        {
          "components": [
            {
              "internalType": "address",
              "name": "owner",
              "type": "address"
            },
            {
              "internalType": "uint256",
              "name": "overhead",
              "type": "uint256"
            },
            {
              "internalType": "uint256",
              "name": "scalar",
              "type": "uint256"
            },
            {
              "internalType": "bytes32",
              "name": "batcherHash",
              "type": "bytes32"
            },
            {
              "internalType": "uint64",
              "name": "gasLimit",
              "type": "uint64"
            },
            {
              "internalType": "address",
              "name": "unsafeBlockSigner",
              "type": "address"
            },
            {
              "components": [
                {
                  "internalType": "uint32",
                  "name": "maxResourceLimit",
                  "type": "uint32"
                },
                {
                  "internalType": "uint8",
                  "name": "elasticityMultiplier",
                  "type": "uint8"
                },
                {
                  "internalType": "uint8",
                  "name": "baseFeeMaxChangeDenominator",
                  "type": "uint8"
                },
                {
                  "internalType": "uint32",
                  "name": "minimumBaseFee",
                  "type": "uint32"
                },
                {
                  "internalType": "uint32",
                  "name": "systemTxMaxGas",
                  "type": "uint32"
                },
                {
                  "internalType": "uint128",
                  "name": "maximumBaseFee",
                  "type": "uint128"
                }
              ],
              "internalType": "struct ResourceMetering.ResourceConfig",
              "name": "resourceConfig",
              "type": "tuple"
            }
          ],
          "internalType": "struct SystemDictator.SystemConfigConfig",
          "name": "systemConfigConfig",
          "type": "tuple"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "currentStep",
      "outputs": [
        {
          "internalType": "uint8",
          "name": "",
          "type": "uint8"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "dynamicConfigSet",
      "outputs": [
        {
          "internalType": "bool",
          "name": "",
          "type": "bool"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "exit1",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "exited",
      "outputs": [
        {
          "internalType": "bool",
          "name": "",
          "type": "bool"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "finalize",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "finalized",
      "outputs": [
        {
          "internalType": "bool",
          "name": "",
          "type": "bool"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [
        {
          "components": [
            {
              "components": [
                {
                  "internalType": "contract AddressManager",
                  "name": "addressManager",
                  "type": "address"
                },
                {
                  "internalType": "contract ProxyAdmin",
                  "name": "proxyAdmin",
                  "type": "address"
                },
                {
                  "internalType": "address",
                  "name": "controller",
                  "type": "address"
                },
                {
                  "internalType": "address",
                  "name": "finalOwner",
                  "type": "address"
                }
              ],
              "internalType": "struct SystemDictator.GlobalConfig",
              "name": "globalConfig",
              "type": "tuple"
            },
            {
              "components": [
                {
                  "internalType": "address",
                  "name": "l2OutputOracleProxy",
                  "type": "address"
                },
                {
                  "internalType": "address",
                  "name": "optimismPortalProxy",
                  "type": "address"
                },
                {
                  "internalType": "address",
                  "name": "l1CrossDomainMessengerProxy",
                  "type": "address"
                },
                {
                  "internalType": "address",
                  "name": "l1StandardBridgeProxy",
                  "type": "address"
                },
                {
                  "internalType": "address",
                  "name": "optimismMintableERC20FactoryProxy",
                  "type": "address"
                },
                {
                  "internalType": "address",
                  "name": "l1ERC721BridgeProxy",
                  "type": "address"
                },
                {
                  "internalType": "address",
                  "name": "systemConfigProxy",
                  "type": "address"
                }
              ],
              "internalType": "struct SystemDictator.ProxyAddressConfig",
              "name": "proxyAddressConfig",
              "type": "tuple"
            },
            {
              "components": [
                {
                  "internalType": "contract L2OutputOracle",
                  "name": "l2OutputOracleImpl",
                  "type": "address"
                },
                {
                  "internalType": "contract OptimismPortal",
                  "name": "optimismPortalImpl",
                  "type": "address"
                },
                {
                  "internalType": "contract L1CrossDomainMessenger",
                  "name": "l1CrossDomainMessengerImpl",
                  "type": "address"
                },
                {
                  "internalType": "contract L1StandardBridge",
                  "name": "l1StandardBridgeImpl",
                  "type": "address"
                },
                {
                  "internalType": "contract OptimismMintableERC20Factory",
                  "name": "optimismMintableERC20FactoryImpl",
                  "type": "address"
                },
                {
                  "internalType": "contract L1ERC721Bridge",
                  "name": "l1ERC721BridgeImpl",
                  "type": "address"
                },
                {
                  "internalType": "contract PortalSender",
                  "name": "portalSenderImpl",
                  "type": "address"
                },
                {
                  "internalType": "contract SystemConfig",
                  "name": "systemConfigImpl",
                  "type": "address"
                }
              ],
              "internalType": "struct SystemDictator.ImplementationAddressConfig",
              "name": "implementationAddressConfig",
              "type": "tuple"
            },
            {
              "components": [
                {
                  "internalType": "address",
                  "name": "owner",
                  "type": "address"
                },
                {
                  "internalType": "uint256",
                  "name": "overhead",
                  "type": "uint256"
                },
                {
                  "internalType": "uint256",
                  "name": "scalar",
                  "type": "uint256"
                },
                {
                  "internalType": "bytes32",
                  "name": "batcherHash",
                  "type": "bytes32"
                },
                {
                  "internalType": "uint64",
                  "name": "gasLimit",
                  "type": "uint64"
                },
                {
                  "internalType": "address",
                  "name": "unsafeBlockSigner",
                  "type": "address"
                },
                {
                  "components": [
                    {
                      "internalType": "uint32",
                      "name": "maxResourceLimit",
                      "type": "uint32"
                    },
                    {
                      "internalType": "uint8",
                      "name": "elasticityMultiplier",
                      "type": "uint8"
                    },
                    {
                      "internalType": "uint8",
                      "name": "baseFeeMaxChangeDenominator",
                      "type": "uint8"
                    },
                    {
                      "internalType": "uint32",
                      "name": "minimumBaseFee",
                      "type": "uint32"
                    },
                    {
                      "internalType": "uint32",
                      "name": "systemTxMaxGas",
                      "type": "uint32"
                    },
                    {
                      "internalType": "uint128",
                      "name": "maximumBaseFee",
                      "type": "uint128"
                    }
                  ],
                  "internalType": "struct ResourceMetering.ResourceConfig",
                  "name": "resourceConfig",
                  "type": "tuple"
                }
              ],
              "internalType": "struct SystemDictator.SystemConfigConfig",
              "name": "systemConfigConfig",
              "type": "tuple"
            }
          ],
          "internalType": "struct SystemDictator.DeployConfig",
          "name": "_config",
          "type": "tuple"
        }
      ],
      "name": "initialize",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "l2OutputOracleDynamicConfig",
      "outputs": [
        {
          "internalType": "uint256",
          "name": "l2OutputOracleStartingBlockNumber",
          "type": "uint256"
        },
        {
          "internalType": "uint256",
          "name": "l2OutputOracleStartingTimestamp",
          "type": "uint256"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "oldL1CrossDomainMessenger",
      "outputs": [
        {
          "internalType": "address",
          "name": "",
          "type": "address"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "optimismPortalDynamicConfig",
      "outputs": [
        {
          "internalType": "bool",
          "name": "",
          "type": "bool"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "owner",
      "outputs": [
        {
          "internalType": "address",
          "name": "",
          "type": "address"
        }
      ],
      "stateMutability": "view",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "phase1",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "phase2",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "renounceOwnership",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "step1",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "step2",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "step3",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "step4",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [],
      "name": "step5",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [
        {
          "internalType": "address",
          "name": "newOwner",
          "type": "address"
        }
      ],
      "name": "transferOwnership",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    },
    {
      "inputs": [
        {
          "components": [
            {
              "internalType": "uint256",
              "name": "l2OutputOracleStartingBlockNumber",
              "type": "uint256"
            },
            {
              "internalType": "uint256",
              "name": "l2OutputOracleStartingTimestamp",
              "type": "uint256"
            }
          ],
          "internalType": "struct SystemDictator.L2OutputOracleDynamicConfig",
          "name": "_l2OutputOracleDynamicConfig",
          "type": "tuple"
        },
        {
          "internalType": "bool",
          "name": "_optimismPortalDynamicConfig",
          "type": "bool"
        }
      ],
      "name": "updateDynamicConfig",
      "outputs": [],
      "stateMutability": "nonpayable",
      "type": "function"
    }
  ],
  "transactionHash": "0xaca6cdc0a101d28f869a0acfb58a6527ffbbee2bb929bd33cc143f8256639dce",
  "receipt": {
    "to": null,
    "from": "0x354F3f4ECdcA5E0A7acE08d71348cdC1Dab48960",
    "contractAddress": "0x09E040a72FD3492355C5aEEdbC3154075f83488a",
    "transactionIndex": 107,
    "gasUsed": "3480736",
    "logsBloom": "0x00000800000000000000000000000000000000000000400000800000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000040001000000000000000000000000000000000000020000000000000000000800000000000020000000000000000000400000000000000000000000020000000000000000000080000000000000000000000000010000000000000000000400000000000000000000000000000000000000000000000000000000000000040000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000000",
    "blockHash": "0x03e7785abc4b15223aad4b7a52b0ece0c5b9c21d4efa3473435697f373d16dd9",
    "transactionHash": "0xaca6cdc0a101d28f869a0acfb58a6527ffbbee2bb929bd33cc143f8256639dce",
    "logs": [
      {
        "transactionIndex": 107,
        "blockNumber": 17365813,
        "transactionHash": "0xaca6cdc0a101d28f869a0acfb58a6527ffbbee2bb929bd33cc143f8256639dce",
        "address": "0x09E040a72FD3492355C5aEEdbC3154075f83488a",
        "topics": [
          "0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0",
          "0x0000000000000000000000000000000000000000000000000000000000000000",
          "0x000000000000000000000000354f3f4ecdca5e0a7ace08d71348cdc1dab48960"
        ],
        "data": "0x",
        "logIndex": 273,
        "blockHash": "0x03e7785abc4b15223aad4b7a52b0ece0c5b9c21d4efa3473435697f373d16dd9"
      },
      {
        "transactionIndex": 107,
        "blockNumber": 17365813,
        "transactionHash": "0xaca6cdc0a101d28f869a0acfb58a6527ffbbee2bb929bd33cc143f8256639dce",
        "address": "0x09E040a72FD3492355C5aEEdbC3154075f83488a",
        "topics": [
          "0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0",
          "0x000000000000000000000000354f3f4ecdca5e0a7ace08d71348cdc1dab48960",
          "0x0000000000000000000000000000000000000000000000000000000000000000"
        ],
        "data": "0x",
        "logIndex": 274,
        "blockHash": "0x03e7785abc4b15223aad4b7a52b0ece0c5b9c21d4efa3473435697f373d16dd9"
      },
      {
        "transactionIndex": 107,
        "blockNumber": 17365813,
        "transactionHash": "0xaca6cdc0a101d28f869a0acfb58a6527ffbbee2bb929bd33cc143f8256639dce",
        "address": "0x09E040a72FD3492355C5aEEdbC3154075f83488a",
        "topics": [
          "0x7f26b83ff96e1f2b6a682f133852f6798a09c465da95921460cefb3847402498"
        ],
        "data": "0x0000000000000000000000000000000000000000000000000000000000000001",
        "logIndex": 275,
        "blockHash": "0x03e7785abc4b15223aad4b7a52b0ece0c5b9c21d4efa3473435697f373d16dd9"
      }
    ],
    "blockNumber": 17365813,
    "cumulativeGasUsed": "12742741",
    "status": 1,
    "byzantium": true
  },
  "args": [],
  "numDeployments": 1,
  "solcInputHash": "13ac93d026822f719ad110af836d1582",
  "metadata": "{\"compiler\":{\"version\":\"0.8.15+commit.e14f2714\"},\"language\":\"Solidity\",\"output\":{\"abi\":[{\"inputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"constructor\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint8\",\"name\":\"version\",\"type\":\"uint8\"}],\"name\":\"Initialized\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"previousOwner\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"OwnershipTransferred\",\"type\":\"event\"},{\"inputs\":[],\"name\":\"EXIT_1_NO_RETURN_STEP\",\"outputs\":[{\"internalType\":\"uint8\",\"name\":\"\",\"type\":\"uint8\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"PROXY_TRANSFER_STEP\",\"outputs\":[{\"internalType\":\"uint8\",\"name\":\"\",\"type\":\"uint8\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"config\",\"outputs\":[{\"components\":[{\"internalType\":\"contract AddressManager\",\"name\":\"addressManager\",\"type\":\"address\"},{\"internalType\":\"contract ProxyAdmin\",\"name\":\"proxyAdmin\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"controller\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"finalOwner\",\"type\":\"address\"}],\"internalType\":\"struct SystemDictator.GlobalConfig\",\"name\":\"globalConfig\",\"type\":\"tuple\"},{\"components\":[{\"internalType\":\"address\",\"name\":\"l2OutputOracleProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"optimismPortalProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"l1CrossDomainMessengerProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"l1StandardBridgeProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"optimismMintableERC20FactoryProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"l1ERC721BridgeProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"systemConfigProxy\",\"type\":\"address\"}],\"internalType\":\"struct SystemDictator.ProxyAddressConfig\",\"name\":\"proxyAddressConfig\",\"type\":\"tuple\"},{\"components\":[{\"internalType\":\"contract L2OutputOracle\",\"name\":\"l2OutputOracleImpl\",\"type\":\"address\"},{\"internalType\":\"contract OptimismPortal\",\"name\":\"optimismPortalImpl\",\"type\":\"address\"},{\"internalType\":\"contract L1CrossDomainMessenger\",\"name\":\"l1CrossDomainMessengerImpl\",\"type\":\"address\"},{\"internalType\":\"contract L1StandardBridge\",\"name\":\"l1StandardBridgeImpl\",\"type\":\"address\"},{\"internalType\":\"contract OptimismMintableERC20Factory\",\"name\":\"optimismMintableERC20FactoryImpl\",\"type\":\"address\"},{\"internalType\":\"contract L1ERC721Bridge\",\"name\":\"l1ERC721BridgeImpl\",\"type\":\"address\"},{\"internalType\":\"contract PortalSender\",\"name\":\"portalSenderImpl\",\"type\":\"address\"},{\"internalType\":\"contract SystemConfig\",\"name\":\"systemConfigImpl\",\"type\":\"address\"}],\"internalType\":\"struct SystemDictator.ImplementationAddressConfig\",\"name\":\"implementationAddressConfig\",\"type\":\"tuple\"},{\"components\":[{\"internalType\":\"address\",\"name\":\"owner\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"overhead\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"scalar\",\"type\":\"uint256\"},{\"internalType\":\"bytes32\",\"name\":\"batcherHash\",\"type\":\"bytes32\"},{\"internalType\":\"uint64\",\"name\":\"gasLimit\",\"type\":\"uint64\"},{\"internalType\":\"address\",\"name\":\"unsafeBlockSigner\",\"type\":\"address\"},{\"components\":[{\"internalType\":\"uint32\",\"name\":\"maxResourceLimit\",\"type\":\"uint32\"},{\"internalType\":\"uint8\",\"name\":\"elasticityMultiplier\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"baseFeeMaxChangeDenominator\",\"type\":\"uint8\"},{\"internalType\":\"uint32\",\"name\":\"minimumBaseFee\",\"type\":\"uint32\"},{\"internalType\":\"uint32\",\"name\":\"systemTxMaxGas\",\"type\":\"uint32\"},{\"internalType\":\"uint128\",\"name\":\"maximumBaseFee\",\"type\":\"uint128\"}],\"internalType\":\"struct ResourceMetering.ResourceConfig\",\"name\":\"resourceConfig\",\"type\":\"tuple\"}],\"internalType\":\"struct SystemDictator.SystemConfigConfig\",\"name\":\"systemConfigConfig\",\"type\":\"tuple\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"currentStep\",\"outputs\":[{\"internalType\":\"uint8\",\"name\":\"\",\"type\":\"uint8\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"dynamicConfigSet\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"exit1\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"exited\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"finalize\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"finalized\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"components\":[{\"components\":[{\"internalType\":\"contract AddressManager\",\"name\":\"addressManager\",\"type\":\"address\"},{\"internalType\":\"contract ProxyAdmin\",\"name\":\"proxyAdmin\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"controller\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"finalOwner\",\"type\":\"address\"}],\"internalType\":\"struct SystemDictator.GlobalConfig\",\"name\":\"globalConfig\",\"type\":\"tuple\"},{\"components\":[{\"internalType\":\"address\",\"name\":\"l2OutputOracleProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"optimismPortalProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"l1CrossDomainMessengerProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"l1StandardBridgeProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"optimismMintableERC20FactoryProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"l1ERC721BridgeProxy\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"systemConfigProxy\",\"type\":\"address\"}],\"internalType\":\"struct SystemDictator.ProxyAddressConfig\",\"name\":\"proxyAddressConfig\",\"type\":\"tuple\"},{\"components\":[{\"internalType\":\"contract L2OutputOracle\",\"name\":\"l2OutputOracleImpl\",\"type\":\"address\"},{\"internalType\":\"contract OptimismPortal\",\"name\":\"optimismPortalImpl\",\"type\":\"address\"},{\"internalType\":\"contract L1CrossDomainMessenger\",\"name\":\"l1CrossDomainMessengerImpl\",\"type\":\"address\"},{\"internalType\":\"contract L1StandardBridge\",\"name\":\"l1StandardBridgeImpl\",\"type\":\"address\"},{\"internalType\":\"contract OptimismMintableERC20Factory\",\"name\":\"optimismMintableERC20FactoryImpl\",\"type\":\"address\"},{\"internalType\":\"contract L1ERC721Bridge\",\"name\":\"l1ERC721BridgeImpl\",\"type\":\"address\"},{\"internalType\":\"contract PortalSender\",\"name\":\"portalSenderImpl\",\"type\":\"address\"},{\"internalType\":\"contract SystemConfig\",\"name\":\"systemConfigImpl\",\"type\":\"address\"}],\"internalType\":\"struct SystemDictator.ImplementationAddressConfig\",\"name\":\"implementationAddressConfig\",\"type\":\"tuple\"},{\"components\":[{\"internalType\":\"address\",\"name\":\"owner\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"overhead\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"scalar\",\"type\":\"uint256\"},{\"internalType\":\"bytes32\",\"name\":\"batcherHash\",\"type\":\"bytes32\"},{\"internalType\":\"uint64\",\"name\":\"gasLimit\",\"type\":\"uint64\"},{\"internalType\":\"address\",\"name\":\"unsafeBlockSigner\",\"type\":\"address\"},{\"components\":[{\"internalType\":\"uint32\",\"name\":\"maxResourceLimit\",\"type\":\"uint32\"},{\"internalType\":\"uint8\",\"name\":\"elasticityMultiplier\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"baseFeeMaxChangeDenominator\",\"type\":\"uint8\"},{\"internalType\":\"uint32\",\"name\":\"minimumBaseFee\",\"type\":\"uint32\"},{\"internalType\":\"uint32\",\"name\":\"systemTxMaxGas\",\"type\":\"uint32\"},{\"internalType\":\"uint128\",\"name\":\"maximumBaseFee\",\"type\":\"uint128\"}],\"internalType\":\"struct ResourceMetering.ResourceConfig\",\"name\":\"resourceConfig\",\"type\":\"tuple\"}],\"internalType\":\"struct SystemDictator.SystemConfigConfig\",\"name\":\"systemConfigConfig\",\"type\":\"tuple\"}],\"internalType\":\"struct SystemDictator.DeployConfig\",\"name\":\"_config\",\"type\":\"tuple\"}],\"name\":\"initialize\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"l2OutputOracleDynamicConfig\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"l2OutputOracleStartingBlockNumber\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"l2OutputOracleStartingTimestamp\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"oldL1CrossDomainMessenger\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"optimismPortalDynamicConfig\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"owner\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"phase1\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"phase2\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"renounceOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"step1\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"step2\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"step3\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"step4\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"step5\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"transferOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"components\":[{\"internalType\":\"uint256\",\"name\":\"l2OutputOracleStartingBlockNumber\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"l2OutputOracleStartingTimestamp\",\"type\":\"uint256\"}],\"internalType\":\"struct SystemDictator.L2OutputOracleDynamicConfig\",\"name\":\"_l2OutputOracleDynamicConfig\",\"type\":\"tuple\"},{\"internalType\":\"bool\",\"name\":\"_optimismPortalDynamicConfig\",\"type\":\"bool\"}],\"name\":\"updateDynamicConfig\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"}],\"devdoc\":{\"kind\":\"dev\",\"methods\":{\"initialize(((address,address,address,address),(address,address,address,address,address,address,address),(address,address,address,address,address,address,address,address),(address,uint256,uint256,bytes32,uint64,address,(uint32,uint8,uint8,uint32,uint32,uint128))))\":{\"params\":{\"_config\":\"System configuration.\"}},\"owner()\":{\"details\":\"Returns the address of the current owner.\"},\"renounceOwnership()\":{\"details\":\"Leaves the contract without owner. It will not be possible to call `onlyOwner` functions anymore. Can only be called by the current owner. NOTE: Renouncing ownership will leave the contract without an owner, thereby removing any functionality that is only available to the owner.\"},\"transferOwnership(address)\":{\"details\":\"Transfers ownership of the contract to a new account (`newOwner`). Can only be called by the current owner.\"},\"updateDynamicConfig((uint256,uint256),bool)\":{\"params\":{\"_l2OutputOracleDynamicConfig\":\"Dynamic L2OutputOracle config.\",\"_optimismPortalDynamicConfig\":\"Dynamic OptimismPortal config.\"}}},\"title\":\"SystemDictator\",\"version\":1},\"userdoc\":{\"kind\":\"user\",\"methods\":{\"EXIT_1_NO_RETURN_STEP()\":{\"notice\":\"Step after which exit 1 can no longer be used.\"},\"PROXY_TRANSFER_STEP()\":{\"notice\":\"Step where proxy ownership is transferred.\"},\"config()\":{\"notice\":\"System configuration.\"},\"constructor\":{\"notice\":\"Constructor required to ensure that the implementation of the SystemDictator is         initialized upon deployment.\"},\"currentStep()\":{\"notice\":\"Current step;\"},\"dynamicConfigSet()\":{\"notice\":\"Whether or not dynamic config has been set.\"},\"exit1()\":{\"notice\":\"First exit point, can only be called before step 3 is executed.\"},\"exited()\":{\"notice\":\"Whether or not the deployment has been exited.\"},\"finalize()\":{\"notice\":\"Tranfers admin ownership to the final owner.\"},\"finalized()\":{\"notice\":\"Whether or not the deployment is finalized.\"},\"l2OutputOracleDynamicConfig()\":{\"notice\":\"Dynamic configuration for the L2OutputOracle.\"},\"oldL1CrossDomainMessenger()\":{\"notice\":\"Address of the old L1CrossDomainMessenger implementation.\"},\"optimismPortalDynamicConfig()\":{\"notice\":\"Dynamic configuration for the OptimismPortal. Determines         if the system should be paused when initialized.\"},\"phase1()\":{\"notice\":\"Calls the first 2 steps of the migration process.\"},\"phase2()\":{\"notice\":\"Calls the remaining steps of the migration process, and finalizes.\"},\"step1()\":{\"notice\":\"Configures the ProxyAdmin contract.\"},\"step2()\":{\"notice\":\"Pauses the system by shutting down the L1CrossDomainMessenger and setting the         deposit halt flag to tell the Sequencer's DTL to stop accepting deposits.\"},\"step3()\":{\"notice\":\"Removes deprecated addresses from the AddressManager.\"},\"step4()\":{\"notice\":\"Transfers system ownership to the ProxyAdmin.\"},\"step5()\":{\"notice\":\"Upgrades and initializes proxy contracts.\"},\"updateDynamicConfig((uint256,uint256),bool)\":{\"notice\":\"Allows the owner to update dynamic config.\"}},\"notice\":\"The SystemDictator is responsible for coordinating the deployment of a full Bedrock         system. The SystemDictator is designed to support both fresh network deployments and         upgrades to existing pre-Bedrock systems.\",\"version\":1}},\"settings\":{\"compilationTarget\":{\"contracts/deployment/SystemDictator.sol\":\"SystemDictator\"},\"evmVersion\":\"london\",\"libraries\":{},\"metadata\":{\"bytecodeHash\":\"none\"},\"optimizer\":{\"enabled\":true,\"runs\":999999},\"remappings\":[\":@cwia/=node_modules/clones-with-immutable-args/src/\",\":@openzeppelin/=node_modules/@openzeppelin/\",\":@openzeppelin/contracts-upgradeable/=node_modules/@openzeppelin/contracts-upgradeable/\",\":@openzeppelin/contracts/=node_modules/@openzeppelin/contracts/\",\":@rari-capital/=node_modules/@rari-capital/\",\":@rari-capital/solmate/=node_modules/@rari-capital/solmate/\",\":clones-with-immutable-args/=node_modules/clones-with-immutable-args/\",\":ds-test/=node_modules/ds-test/src/\",\":forge-std/=node_modules/forge-std/src/\"]},\"sources\":{\"contracts/L1/L1CrossDomainMessenger.sol\":{\"keccak256\":\"0xeaaa55074aa93641ab9423033a25beeee8b93900b556a059338d77c29b1c7e5f\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://cdce427876bf3cce02395d716a23675990800c4236f1b99f606ea63ae535ca06\",\"dweb:/ipfs/QmT5gBeR4dH5M6KRvtUKfKVMk4b3528vB49Bn9fNEKSPwH\"]},\"contracts/L1/L1ERC721Bridge.sol\":{\"keccak256\":\"0xe1e81e114ab32473e7cbc88a6e686f166e686ae6cc75ecb7cb3f929a30c92458\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://e41cf7b7912446293b5b916c0045bfd25b914fdc1fad0b3b0b471479b55812c4\",\"dweb:/ipfs/QmXkQj7f8pFuoW8UqdW3Mj9u4FdKA6b6qXWHpRJywi3Fwk\"]},\"contracts/L1/L1StandardBridge.sol\":{\"keccak256\":\"0xb2c96bbf32c948863e20a4cd27c0813ae72d8694aaa777fcffb36245bdac6fe3\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://229bb8837204c9996f0b91b8886af05e97095563b376aa9a6e3094d7b6622ffb\",\"dweb:/ipfs/QmXaqGWCxGVQ8B27kKeStP1mYW9H22tyrxaHsuUogttz7N\"]},\"contracts/L1/L2OutputOracle.sol\":{\"keccak256\":\"0xba09a5005080e6c7ccc9e0dab17165f20ae0ef9d9c04a13d0b5c158dc1c2a4bb\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://fce7e5b5fb4882f05ddcd540f4781225bcf95870b5206e1b423a98ddd3e80df2\",\"dweb:/ipfs/QmQxsgVPaZmkW8SKxKtQEmP5ApeXAxaEEC6Hf4AQ4xL3wC\"]},\"contracts/L1/OptimismPortal.sol\":{\"keccak256\":\"0x3b16493feec098a6d70b98a83e0f7c5f541ac33c5265edee77c2c0229c343fd2\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://795b7f9aca7930f9b446d81071ba7d35872f3fbd53faa0e7acb1f51df4edb7f2\",\"dweb:/ipfs/QmTwr3pGnVVN2qfTjPqC5svhM7rLVLgiEj1SthHVz1v4k8\"]},\"contracts/L1/ResourceMetering.sol\":{\"keccak256\":\"0xbd7b9532a70d8c842bfce0ea971be50d02fbbf0227c9ad55c71ac68d438010f4\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://4969f478dd54e89392cda2ea0c5edcf1be55a5dee43a0e410527b6e3bcb85c88\",\"dweb:/ipfs/QmU2crAojw8DRDsz7PAPrereazjFsKh9wtfTpTDVh6NLfW\"]},\"contracts/L1/SystemConfig.sol\":{\"keccak256\":\"0x2202e03df7b5f70b0cf1cf942afe51cab165bf35864a77d6a77dc82c55653689\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://42ec7d69b192c6199bf28ccf1d19d896f01807039f6bdc3e871b52eb7d9ee645\",\"dweb:/ipfs/QmPmWLf9a9FJ2fYQi9nP73e4QRnAMDbrfNwLS1u8KZgrEs\"]},\"contracts/L2/L2ERC721Bridge.sol\":{\"keccak256\":\"0x94d240acff616f7ec4281bb3c2d3cace1c398bfca754fb3ca7bc795c875b4f10\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://7613d2506fc31214e3e36c8cd9b0845c9bcaaf063be6fc611ce8efe3fce71584\",\"dweb:/ipfs/QmX8eBBgEWvUPXgpQsPQN3ZhZbwMawFQRuqyTF8Rcv1u1S\"]},\"contracts/deployment/PortalSender.sol\":{\"keccak256\":\"0xe60d88036d9aa8f8e80a4108ee30ad987564ad996af87a79ba92f6ca35852881\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://a4be187cd3d5926592491f722dfa1b1c41a8f4f1abdc8cf3883964f70acb0a44\",\"dweb:/ipfs/QmYsAK4YcRHmPoex2eX2x1r6N76AMk3rdBHHmp6gUT73Fa\"]},\"contracts/deployment/SystemDictator.sol\":{\"keccak256\":\"0x4539f2205aa2b1f0502d2b58f6f97772768dc4424333a2acae89dd00c6b0901d\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://3917b358bf76ee85a534406a12e149df92dca5d404f3aab6a0c4f6dc490f3ad0\",\"dweb:/ipfs/QmdvBYGNKR6pdMBgQGjSgy75i4PtYtr6ZWgjRgv9kMqcq1\"]},\"contracts/legacy/AddressManager.sol\":{\"keccak256\":\"0x7a353d4c92eed32665fd2f0023c55054901293cf7a6e14ca108229d87c047b10\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://b92ba23601d1951271729a20db931a45639d9376b7c8e2705c23dc360833715a\",\"dweb:/ipfs/QmTKwYLNYYBKZpd31VNBANmguVUwFZifSg7joHSgLZjZCj\"]},\"contracts/legacy/L1ChugSplashProxy.sol\":{\"keccak256\":\"0x6ae7bf6ea9ac0e3511ee4cb15d946589da0dd35098ff762c0b2903d064f24875\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://02028d86c1d38563021d5ead5282271ccdf1c03a24f2eaee056ae2157f0554ee\",\"dweb:/ipfs/QmW9urkBBRTmZ8FjL5Y5zWbdnRhPDruxCCLnpr2CTkozKM\"]},\"contracts/libraries/Arithmetic.sol\":{\"keccak256\":\"0xc8858039f87e48e6f18c1af8bc0b03e57cfef564acddfd06e4d91e3db7ac5ed6\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://2fc79af1e844aa6dc1c68067bfe1d359df8d4e9a3e8881afb3bcfcbf68071714\",\"dweb:/ipfs/QmcNC4k8zmvwj4kZizSenTiWbx2DJQPbwqXXLF4iMbkRVD\"]},\"contracts/libraries/Burn.sol\":{\"keccak256\":\"0x54233b226ba6919dc46d438bc790108d8f855001002a1b9c3c37aed7a83e5f3f\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://4051a4baca357a9191a6c9e3aa1593a17b69dd7915966e23e4cb269e9c1d9ed4\",\"dweb:/ipfs/QmadKjGKvxm53abVHQdsxrXBc8e9jXywu6vvhkAgjsx59J\"]},\"contracts/libraries/Bytes.sol\":{\"keccak256\":\"0x7aca6593fadf438ee9cd090d8fdc8f94a5202a2eb7f764c9a86f207712d87a48\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://aac32157885c5a08bd0bc7dcd5511f66db12bb20d0c263dd7be9f58b91538fc1\",\"dweb:/ipfs/Qmb1iG11Z53yt9wNbGsuTvoydJXFosDDpWwRSADKyqiCjw\"]},\"contracts/libraries/Constants.sol\":{\"keccak256\":\"0x8c7be28a175eb732995a7f704560163c30261f9f70d377f865c5060882509f5d\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://f72aba26553b10ca88708e05461691b36b0d2ec7a87f718022fe119ca9c70852\",\"dweb:/ipfs/QmQtDEB1F3D8RsgG63KSJ9t7ZyFLaXc2Av81vKD9y2TMn7\"]},\"contracts/libraries/Encoding.sol\":{\"keccak256\":\"0x170cd0821cec37976a6391da20f1dcdcb1ea9ffada96ccd3c57ff2e357589418\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://f18156216c1f9457c2e032a812ad70f2babbc5b89997554ff014d64c483fb2ff\",\"dweb:/ipfs/Qmc5rjMaBFn3jV7XqDrEvRbmatQvJxeVJYA5B5rdcKPkcJ\"]},\"contracts/libraries/Hashing.sol\":{\"keccak256\":\"0x5d4988987899306d2785b3de068194a39f8e829a7864762a07a0016db5189f5e\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://6746ed0d26d603568818cc52a29d0209effd69f7e55bd0017a6b91bd6cf319fe\",\"dweb:/ipfs/QmPebCmCELMBRtDDxt5ziEPfRXUh6tfm2qJdwz3iyrDdWN\"]},\"contracts/libraries/Predeploys.sol\":{\"keccak256\":\"0xfc30fb239b5f00284f4b8f578a62f0882597e939335c91ea9bc4aab3070ddc43\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://fa132267b3a9d98568b4e02cbb68fe2d2c0ca630826242c1b2293a8fa35bd302\",\"dweb:/ipfs/QmdYvcGbaykP6wyBu5T2obXrWK56xGnfWqbYeeWpTChq3w\"]},\"contracts/libraries/SafeCall.sol\":{\"keccak256\":\"0x3deedbfc0a57228366531a4f09c94d174f0bb4ea49476a92226d471f3abb349b\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://e8091b178f6710cb7738f07b1706fe18c241b6275b6641b32724d4ecf5a087dd\",\"dweb:/ipfs/Qmd5kchcZhHepJ3boHRTVDJUr9jsuweWEyoUmNmMFJB6vp\"]},\"contracts/libraries/Types.sol\":{\"keccak256\":\"0x4fe8ec920798661a828430bd30dc2715eeb40534ec01c0a7bf41cb4ab422e134\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://74c8471869900bd459358cd990bda1c8d234c06b788804c7049cf465ae1e299f\",\"dweb:/ipfs/QmakcfP6NmbVUQsKqH7rEyJsbiqckigLahw9g74oencEJ7\"]},\"contracts/libraries/rlp/RLPReader.sol\":{\"keccak256\":\"0x50763c897f0fe84cb067985ec4d7c5721ce9004a69cf0327f96f8982ee8ca412\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://603af847b43933b075f9aac3a7b3cd65041ffe6d732826695458ca9575e1a809\",\"dweb:/ipfs/QmfByFEaCxT9y1VtqoLi5EsXZ9ihkPfj6g5x7pcPoQ7q2K\"]},\"contracts/libraries/rlp/RLPWriter.sol\":{\"keccak256\":\"0x5aa9d21c5b41c9786f23153f819d561ae809a1d55c7b0d423dfeafdfbacedc78\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://921c44e6a0982b9a4011900fda1bda2c06b7a85894967de98b407a83fe9f90c0\",\"dweb:/ipfs/QmSsHLKDUQ82kpKdqB6VntVGKuPDb4W9VdotsubuqWBzio\"]},\"contracts/libraries/trie/MerkleTrie.sol\":{\"keccak256\":\"0xd27fc945d6dd2821636d840f3766f817823c8e9fbfdb87c2da7c73e4292d2f7f\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://497cec37d09ebcdc8d1cccac608a4a0b9b9d83eac6cc7c9e8b73c4c6644e2209\",\"dweb:/ipfs/QmUYMsCcgU6epspvKV9Y6anHyyMb4hd1xVzUZheBY9mfG7\"]},\"contracts/libraries/trie/SecureMerkleTrie.sol\":{\"keccak256\":\"0x61b03a03779cb1f75cea3b88af16fdfd10629029b4b2d6be5238e71af8ef1b5f\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://1212951af291c0e033a7119b42de5cad6b6bf32da26777da7c2419e76fa8f314\",\"dweb:/ipfs/QmYbnifDmL6UkP9D1X9GaNLR1Q8wYwmDNeYqkJ71bycaE5\"]},\"contracts/universal/CrossDomainMessenger.sol\":{\"keccak256\":\"0x3c99b1e768cc4c1e064ccc137b1b4d5961bf4edf071be84cc216c5b20f1c00da\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://e36b2a6325c2f804d769271575669b62ab2da2df3c81921ac7487399fe02af07\",\"dweb:/ipfs/QmTCmcEKwvD8Xvjyev268Bkz27FC7TJpUbw1nADcsThnUr\"]},\"contracts/universal/ERC721Bridge.sol\":{\"keccak256\":\"0xb47389fbec63e85b2d04fce538fe1b8e048278d631729458b70e32a31971c092\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://7133f38e3d8d1911738057b1d4523989abd7cd029797b1d3b59cda29d42e9704\",\"dweb:/ipfs/QmUN31CLssESHrBwWA3WYP5L2xESo9Q4aq2Exua1e8UtUW\"]},\"contracts/universal/IOptimismMintableERC20.sol\":{\"keccak256\":\"0x2fea0ee05071c9c6b06a34a8e805801e247e861359b376a8918106e1d6f77ebe\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://198c91bda2edf864ddad1f8ab6168155d13d6ba5487418e5531ff040ff250686\",\"dweb:/ipfs/QmQzxfHY4P7zdVFRh2DTdGt1KeMHaGKNRf3KPZ1mRTYEGB\"]},\"contracts/universal/IOptimismMintableERC721.sol\":{\"keccak256\":\"0xf1a3dd4452df8882a65a31c5e2e8de7872b08cf078be7a5a7da51e6f75c53ad3\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://b09a2560cae35ca4789fe1ff5edb2bae9fa7dcda115a55f7ccdcc974a2e37526\",\"dweb:/ipfs/QmPQeTvrJ4SJpng5VGZNMf1u85NWxrdus4gGn8xYkHddKM\"]},\"contracts/universal/OptimismMintableERC20.sol\":{\"keccak256\":\"0x302094342a45ebdf7f46f4fb48821960d2a4134f66fd7f458f73fc4ddf34d219\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://8b0e2b496e966ca6037e1c9be1d44417c0180fda2a27f68114e93b899defb783\",\"dweb:/ipfs/QmXP76ivMLxYxscC7B9E9qtW3u6HJ2MNaRVeo3x24VEAQH\"]},\"contracts/universal/OptimismMintableERC20Factory.sol\":{\"keccak256\":\"0x87fde59e9b0d43c415cb26d0cb13d7b1aab1f725750291dd257276efdf83774b\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://e76b70b637fd5d4daf121ba201dd3c85e5ca9763adf65f032c49753057d2c9af\",\"dweb:/ipfs/Qmf5SWFCS2TB1VM5BfGfb8EG84H8mdVwXe9A5jipgf4Lgr\"]},\"contracts/universal/Proxy.sol\":{\"keccak256\":\"0x64d67f1936d97c87a2e42317eb162744ad5cefdc9bc8b1138ee4afe2886eb885\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://33b903585eb9cfc60a70bcdf4ee44220b173caff16dfb9071cd0668c7a551265\",\"dweb:/ipfs/QmXHUZ9brinN1WS9i63ocRQsQidY96WePDBhBsFRhDmVjr\"]},\"contracts/universal/ProxyAdmin.sol\":{\"keccak256\":\"0x7326011ac425cc9ab4760c29ca559342d4832633b5019a9a61b9e63067374e2a\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://7d3541272c48443f0b339998553e44600b7bcb4f949e5c94acb5a3acfce19399\",\"dweb:/ipfs/QmNSd9jxACWg8bZE8EgxmRdXwLUQixVs4oiugrVegapUe4\"]},\"contracts/universal/Semver.sol\":{\"keccak256\":\"0x400059d3edb9efc9c23e6fbc18de6710f9235a4ffba4ab23bdb9f825273f093b\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://9baf7797439c0ae6512f4639dfc6a1934dbd4e4d7cbb8e63e99264ff47682c9e\",\"dweb:/ipfs/QmawAuhppPyeoZH3rC1uh87xDELa9Lyfw5pYsBqE8myE1m\"]},\"contracts/universal/StandardBridge.sol\":{\"keccak256\":\"0xaa45044774fa70ed322983c3c0138b21d26d75f4b7e8f5324d53c3eef91adec4\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://c65c95d0cb71f2e32f5ffdea92151a9a46bbd538ba110389a134963fd16a33e9\",\"dweb:/ipfs/QmaPNZokt4j5SCXaWwVtw6qxu5GXWFa3SWBgaSWPPA9KUG\"]},\"contracts/vendor/AddressAliasHelper.sol\":{\"keccak256\":\"0x6ecb83b4ec80fbe49c22f4f95d90482de64660ef5d422a19f4d4b04df31c1237\",\"license\":\"Apache-2.0\",\"urls\":[\"bzz-raw://1d0885be6e473962f9a0622176a22300165ac0cc1a1d7f2e22b11c3d656ace88\",\"dweb:/ipfs/QmPRa3KmRpXW5P9ykveKRDgYN5zYo4cYLAYSnoqHX3KnXR\"]},\"node_modules/@openzeppelin/contracts-upgradeable/access/OwnableUpgradeable.sol\":{\"keccak256\":\"0x247c62047745915c0af6b955470a72d1696ebad4352d7d3011aef1a2463cd888\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://d7fc8396619de513c96b6e00301b88dd790e83542aab918425633a5f7297a15a\",\"dweb:/ipfs/QmXbP4kiZyp7guuS7xe8KaybnwkRPGrBc2Kbi3vhcTfpxb\"]},\"node_modules/@openzeppelin/contracts-upgradeable/proxy/utils/Initializable.sol\":{\"keccak256\":\"0x0203dcadc5737d9ef2c211d6fa15d18ebc3b30dfa51903b64870b01a062b0b4e\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://6eb2fd1e9894dbe778f4b8131adecebe570689e63cf892f4e21257bfe1252497\",\"dweb:/ipfs/QmXgUGNfZvrn6N2miv3nooSs7Jm34A41qz94fu2GtDFcx8\"]},\"node_modules/@openzeppelin/contracts-upgradeable/utils/AddressUpgradeable.sol\":{\"keccak256\":\"0x611aa3f23e59cfdd1863c536776407b3e33d695152a266fa7cfb34440a29a8a3\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://9b4b2110b7f2b3eb32951bc08046fa90feccffa594e1176cb91cdfb0e94726b4\",\"dweb:/ipfs/QmSxLwYjicf9zWFuieRc8WQwE4FisA1Um5jp1iSa731TGt\"]},\"node_modules/@openzeppelin/contracts-upgradeable/utils/ContextUpgradeable.sol\":{\"keccak256\":\"0x963ea7f0b48b032eef72fe3a7582edf78408d6f834115b9feadd673a4d5bd149\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://d6520943ea55fdf5f0bafb39ed909f64de17051bc954ff3e88c9e5621412c79c\",\"dweb:/ipfs/QmWZ4rAKTQbNG2HxGs46AcTXShsVytKeLs7CUCdCSv5N7a\"]},\"node_modules/@openzeppelin/contracts/access/Ownable.sol\":{\"keccak256\":\"0xa94b34880e3c1b0b931662cb1c09e5dfa6662f31cba80e07c5ee71cd135c9673\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://40fb1b5102468f783961d0af743f91b9980cf66b50d1d12009f6bb1869cea4d2\",\"dweb:/ipfs/QmYqEbJML4jB1GHbzD4cUZDtJg5wVwNm3vDJq1GbyDus8y\"]},\"node_modules/@openzeppelin/contracts/proxy/utils/Initializable.sol\":{\"keccak256\":\"0x2a21b14ff90012878752f230d3ffd5c3405e5938d06c97a7d89c0a64561d0d66\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://3313a8f9bb1f9476857c9050067b31982bf2140b83d84f3bc0cec1f62bbe947f\",\"dweb:/ipfs/Qma17Pk8NRe7aB4UD3jjVxk7nSFaov3eQyv86hcyqkwJRV\"]},\"node_modules/@openzeppelin/contracts/token/ERC20/ERC20.sol\":{\"keccak256\":\"0x24b04b8aacaaf1a4a0719117b29c9c3647b1f479c5ac2a60f5ff1bb6d839c238\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://43e46da9d9f49741ecd876a269e71bc7494058d7a8e9478429998adb5bc3eaa0\",\"dweb:/ipfs/QmUtp4cqzf22C5rJ76AabKADquGWcjsc33yjYXxXC4sDvy\"]},\"node_modules/@openzeppelin/contracts/token/ERC20/IERC20.sol\":{\"keccak256\":\"0x9750c6b834f7b43000631af5cc30001c5f547b3ceb3635488f140f60e897ea6b\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://5a7d5b1ef5d8d5889ad2ed89d8619c09383b80b72ab226e0fe7bde1636481e34\",\"dweb:/ipfs/QmebXWgtEfumQGBdVeM6c71McLixYXQP5Bk6kKXuoY4Bmr\"]},\"node_modules/@openzeppelin/contracts/token/ERC20/extensions/IERC20Metadata.sol\":{\"keccak256\":\"0x8de418a5503946cabe331f35fe242d3201a73f67f77aaeb7110acb1f30423aca\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://5a376d3dda2cb70536c0a45c208b29b34ac560c4cb4f513a42079f96ba47d2dd\",\"dweb:/ipfs/QmZQg6gn1sUpM8wHzwNvSnihumUCAhxD119MpXeKp8B9s8\"]},\"node_modules/@openzeppelin/contracts/token/ERC20/extensions/draft-IERC20Permit.sol\":{\"keccak256\":\"0xf41ca991f30855bf80ffd11e9347856a517b977f0a6c2d52e6421a99b7840329\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://b2717fd2bdac99daa960a6de500754ea1b932093c946388c381da48658234b95\",\"dweb:/ipfs/QmP6QVMn6UeA3ByahyJbYQr5M6coHKBKsf3ySZSfbyA8R7\"]},\"node_modules/@openzeppelin/contracts/token/ERC20/utils/SafeERC20.sol\":{\"keccak256\":\"0x032807210d1d7d218963d7355d62e021a84bf1b3339f4f50be2f63b53cccaf29\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://11756f42121f6541a35a8339ea899ee7514cfaa2e6d740625fcc844419296aa6\",\"dweb:/ipfs/QmekMuk6BY4DAjzeXr4MSbKdgoqqsZnA8JPtuyWc6CwXHf\"]},\"node_modules/@openzeppelin/contracts/token/ERC721/IERC721.sol\":{\"keccak256\":\"0xed6a749c5373af398105ce6ee3ac4763aa450ea7285d268c85d9eeca809cdb1f\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://20a97f891d06f0fe91560ea1a142aaa26fdd22bed1b51606b7d48f670deeb50f\",\"dweb:/ipfs/QmTbCtZKChpaX5H2iRiTDMcSz29GSLCpTCDgJpcMR4wg8x\"]},\"node_modules/@openzeppelin/contracts/token/ERC721/extensions/IERC721Enumerable.sol\":{\"keccak256\":\"0xd1556954440b31c97a142c6ba07d5cade45f96fafd52091d33a14ebe365aecbf\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://26fef835622b46a5ba08b3ef6b46a22e94b5f285d0f0fb66b703bd30217d2c34\",\"dweb:/ipfs/QmZ548qdwfL1qF7aXz3xh1GCdTiST81kGGuKRqVUfYmPZR\"]},\"node_modules/@openzeppelin/contracts/utils/Address.sol\":{\"keccak256\":\"0xd6153ce99bcdcce22b124f755e72553295be6abcd63804cfdffceb188b8bef10\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://35c47bece3c03caaa07fab37dd2bb3413bfbca20db7bd9895024390e0a469487\",\"dweb:/ipfs/QmPGWT2x3QHcKxqe6gRmAkdakhbaRgx3DLzcakHz5M4eXG\"]},\"node_modules/@openzeppelin/contracts/utils/Context.sol\":{\"keccak256\":\"0xe2e337e6dde9ef6b680e07338c493ebea1b5fd09b43424112868e9cc1706bca7\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://6df0ddf21ce9f58271bdfaa85cde98b200ef242a05a3f85c2bc10a8294800a92\",\"dweb:/ipfs/QmRK2Y5Yc6BK7tGKkgsgn3aJEQGi5aakeSPZvS65PV8Xp3\"]},\"node_modules/@openzeppelin/contracts/utils/Strings.sol\":{\"keccak256\":\"0xaf159a8b1923ad2a26d516089bceca9bdeaeacd04be50983ea00ba63070f08a3\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://6f2cf1c531122bc7ca96b8c8db6a60deae60441e5223065e792553d4849b5638\",\"dweb:/ipfs/QmPBdJmBBABMDCfyDjCbdxgiqRavgiSL88SYPGibgbPas9\"]},\"node_modules/@openzeppelin/contracts/utils/introspection/ERC165Checker.sol\":{\"keccak256\":\"0xc65c83c1039508fa7a42a09a3c6a32babd1c438ba4dbb23581255e784b5d5eed\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://a1b3b38db0f76429db899909025e534c366415e9ea8b5ddc4c8901e6a7fc1461\",\"dweb:/ipfs/QmYv1KxyHjLEky9JWNSsSfpGJbiCxFyzVFgTwQKpiqYGUg\"]},\"node_modules/@openzeppelin/contracts/utils/introspection/IERC165.sol\":{\"keccak256\":\"0x447a5f3ddc18419d41ff92b3773fb86471b1db25773e07f877f548918a185bf1\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://be161e54f24e5c6fae81a12db1a8ae87bc5ae1b0ddc805d82a1440a68455088f\",\"dweb:/ipfs/QmP7C3CHdY9urF4dEMb9wmsp1wMxHF6nhA2yQE5SKiPAdy\"]},\"node_modules/@openzeppelin/contracts/utils/math/Math.sol\":{\"keccak256\":\"0xd15c3e400531f00203839159b2b8e7209c5158b35618f570c695b7e47f12e9f0\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://b600b852e0597aa69989cc263111f02097e2827edc1bdc70306303e3af5e9929\",\"dweb:/ipfs/QmU4WfM28A1nDqghuuGeFmN3CnVrk6opWtiF65K4vhFPeC\"]},\"node_modules/@openzeppelin/contracts/utils/math/SignedMath.sol\":{\"keccak256\":\"0xb3ebde1c8d27576db912d87c3560dab14adfb9cd001be95890ec4ba035e652e7\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://a709421c4f5d4677db8216055d2d4dac96a613efdb08178a9f7041f0c5cef689\",\"dweb:/ipfs/QmYs2rStvVLDnSJs8HgaMD1ABwoKKWdiVbQyNfLfFWTjTy\"]},\"node_modules/@rari-capital/solmate/src/utils/FixedPointMathLib.sol\":{\"keccak256\":\"0x622fcd8a49e132df5ec7651cc6ae3aaf0cf59bdcd67a9a804a1b9e2485113b7d\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://af77088eb606427d4c55e578984a615779c86bc30646a20f7bb27299ba390f7c\",\"dweb:/ipfs/QmZGQdhdQDtHc7gZXWrKXgA3govc74X8U63BiWhPQK3mK8\"]}},\"version\":1}",
  "bytecode": "[encoded data, 34140 characters]",
  "deployedBytecode": "[encoded data, 30552 characters]",
  "devdoc": {
    "version": 1,
    "kind": "dev",
    "methods": {
      "initialize(((address,address,address,address),(address,address,address,address,address,address,address),(address,address,address,address,address,address,address,address),(address,uint256,uint256,bytes32,uint64,address,(uint32,uint8,uint8,uint32,uint32,uint128))))": {
        "params": {
          "_config": "System configuration."
        }
      },
      "owner()": {
        "details": "Returns the address of the current owner."
      },
      "renounceOwnership()": {
        "details": "Leaves the contract without owner. It will not be possible to call `onlyOwner` functions anymore. Can only be called by the current owner. NOTE: Renouncing ownership will leave the contract without an owner, thereby removing any functionality that is only available to the owner."
      },
      "transferOwnership(address)": {
        "details": "Transfers ownership of the contract to a new account (`newOwner`). Can only be called by the current owner."
      },
      "updateDynamicConfig((uint256,uint256),bool)": {
        "params": {
          "_l2OutputOracleDynamicConfig": "Dynamic L2OutputOracle config.",
          "_optimismPortalDynamicConfig": "Dynamic OptimismPortal config."
        }
      }
    },
    "title": "SystemDictator"
  },
  "userdoc": {
    "version": 1,
    "kind": "user",
    "methods": {
      "EXIT_1_NO_RETURN_STEP()": {
        "notice": "Step after which exit 1 can no longer be used."
      },
      "PROXY_TRANSFER_STEP()": {
        "notice": "Step where proxy ownership is transferred."
      },
      "config()": {
        "notice": "System configuration."
      },
      "constructor": {
        "notice": "Constructor required to ensure that the implementation of the SystemDictator is         initialized upon deployment."
      },
      "currentStep()": {
        "notice": "Current step;"
      },
      "dynamicConfigSet()": {
        "notice": "Whether or not dynamic config has been set."
      },
      "exit1()": {
        "notice": "First exit point, can only be called before step 3 is executed."
      },
      "exited()": {
        "notice": "Whether or not the deployment has been exited."
      },
      "finalize()": {
        "notice": "Tranfers admin ownership to the final owner."
      },
      "finalized()": {
        "notice": "Whether or not the deployment is finalized."
      },
      "l2OutputOracleDynamicConfig()": {
        "notice": "Dynamic configuration for the L2OutputOracle."
      },
      "oldL1CrossDomainMessenger()": {
        "notice": "Address of the old L1CrossDomainMessenger implementation."
      },
      "optimismPortalDynamicConfig()": {
        "notice": "Dynamic configuration for the OptimismPortal. Determines         if the system should be paused when initialized."
      },
      "phase1()": {
        "notice": "Calls the first 2 steps of the migration process."
      },
      "phase2()": {
        "notice": "Calls the remaining steps of the migration process, and finalizes."
      },
      "step1()": {
        "notice": "Configures the ProxyAdmin contract."
      },
      "step2()": {
        "notice": "Pauses the system by shutting down the L1CrossDomainMessenger and setting the         deposit halt flag to tell the Sequencer's DTL to stop accepting deposits."
      },
      "step3()": {
        "notice": "Removes deprecated addresses from the AddressManager."
      },
      "step4()": {
        "notice": "Transfers system ownership to the ProxyAdmin."
      },
      "step5()": {
        "notice": "Upgrades and initializes proxy contracts."
      },
      "updateDynamicConfig((uint256,uint256),bool)": {
        "notice": "Allows the owner to update dynamic config."
      }
    },
    "notice": "The SystemDictator is responsible for coordinating the deployment of a full Bedrock         system. The SystemDictator is designed to support both fresh network deployments and         upgrades to existing pre-Bedrock systems."
  },
  "storageLayout": {
    "storage": [
      {
        "astId": 52671,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "_initialized",
        "offset": 0,
        "slot": "0",
        "type": "t_uint8"
      },
      {
        "astId": 52674,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "_initializing",
        "offset": 1,
        "slot": "0",
        "type": "t_bool"
      },
      {
        "astId": 53099,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "__gap",
        "offset": 0,
        "slot": "1",
        "type": "t_array(t_uint256)50_storage"
      },
      {
        "astId": 52543,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "_owner",
        "offset": 0,
        "slot": "51",
        "type": "t_address"
      },
      {
        "astId": 52663,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "__gap",
        "offset": 0,
        "slot": "52",
        "type": "t_array(t_uint256)49_storage"
      },
      {
        "astId": 4322,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "config",
        "offset": 0,
        "slot": "101",
        "type": "t_struct(DeployConfig)4310_storage"
      },
      {
        "astId": 4326,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "l2OutputOracleDynamicConfig",
        "offset": 0,
        "slot": "126",
        "type": "t_struct(L2OutputOracleDynamicConfig)4281_storage"
      },
      {
        "astId": 4329,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "optimismPortalDynamicConfig",
        "offset": 0,
        "slot": "128",
        "type": "t_bool"
      },
      {
        "astId": 4332,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "currentStep",
        "offset": 1,
        "slot": "128",
        "type": "t_uint8"
      },
      {
        "astId": 4335,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "dynamicConfigSet",
        "offset": 2,
        "slot": "128",
        "type": "t_bool"
      },
      {
        "astId": 4338,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "finalized",
        "offset": 3,
        "slot": "128",
        "type": "t_bool"
      },
      {
        "astId": 4341,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "exited",
        "offset": 4,
        "slot": "128",
        "type": "t_bool"
      },
      {
        "astId": 4344,
        "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
        "label": "oldL1CrossDomainMessenger",
        "offset": 5,
        "slot": "128",
        "type": "t_address"
      }
    ],
    "types": {
      "t_address": {
        "encoding": "inplace",
        "label": "address",
        "numberOfBytes": "20"
      },
      "t_array(t_uint256)49_storage": {
        "encoding": "inplace",
        "label": "uint256[49]",
        "numberOfBytes": "1568",
        "base": "t_uint256"
      },
      "t_array(t_uint256)50_storage": {
        "encoding": "inplace",
        "label": "uint256[50]",
        "numberOfBytes": "1600",
        "base": "t_uint256"
      },
      "t_bool": {
        "encoding": "inplace",
        "label": "bool",
        "numberOfBytes": "1"
      },
      "t_bytes32": {
        "encoding": "inplace",
        "label": "bytes32",
        "numberOfBytes": "32"
      },
      "t_contract(AddressManager)7678": {
        "encoding": "inplace",
        "label": "contract AddressManager",
        "numberOfBytes": "20"
      },
      "t_contract(L1CrossDomainMessenger)125": {
        "encoding": "inplace",
        "label": "contract L1CrossDomainMessenger",
        "numberOfBytes": "20"
      },
      "t_contract(L1ERC721Bridge)325": {
        "encoding": "inplace",
        "label": "contract L1ERC721Bridge",
        "numberOfBytes": "20"
      },
      "t_contract(L1StandardBridge)772": {
        "encoding": "inplace",
        "label": "contract L1StandardBridge",
        "numberOfBytes": "20"
      },
      "t_contract(L2OutputOracle)1233": {
        "encoding": "inplace",
        "label": "contract L2OutputOracle",
        "numberOfBytes": "20"
      },
      "t_contract(OptimismMintableERC20Factory)50636": {
        "encoding": "inplace",
        "label": "contract OptimismMintableERC20Factory",
        "numberOfBytes": "20"
      },
      "t_contract(OptimismPortal)1912": {
        "encoding": "inplace",
        "label": "contract OptimismPortal",
        "numberOfBytes": "20"
      },
      "t_contract(PortalSender)4190": {
        "encoding": "inplace",
        "label": "contract PortalSender",
        "numberOfBytes": "20"
      },
      "t_contract(ProxyAdmin)51686": {
        "encoding": "inplace",
        "label": "contract ProxyAdmin",
        "numberOfBytes": "20"
      },
      "t_contract(SystemConfig)2672": {
        "encoding": "inplace",
        "label": "contract SystemConfig",
        "numberOfBytes": "20"
      },
      "t_struct(DeployConfig)4310_storage": {
        "encoding": "inplace",
        "label": "struct SystemDictator.DeployConfig",
        "numberOfBytes": "800",
        "members": [
          {
            "astId": 4300,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "globalConfig",
            "offset": 0,
            "slot": "0",
            "type": "t_struct(GlobalConfig)4236_storage"
          },
          {
            "astId": 4303,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "proxyAddressConfig",
            "offset": 0,
            "slot": "4",
            "type": "t_struct(ProxyAddressConfig)4251_storage"
          },
          {
            "astId": 4306,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "implementationAddressConfig",
            "offset": 0,
            "slot": "11",
            "type": "t_struct(ImplementationAddressConfig)4276_storage"
          },
          {
            "astId": 4309,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "systemConfigConfig",
            "offset": 0,
            "slot": "19",
            "type": "t_struct(SystemConfigConfig)4297_storage"
          }
        ]
      },
      "t_struct(GlobalConfig)4236_storage": {
        "encoding": "inplace",
        "label": "struct SystemDictator.GlobalConfig",
        "numberOfBytes": "128",
        "members": [
          {
            "astId": 4228,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "addressManager",
            "offset": 0,
            "slot": "0",
            "type": "t_contract(AddressManager)7678"
          },
          {
            "astId": 4231,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "proxyAdmin",
            "offset": 0,
            "slot": "1",
            "type": "t_contract(ProxyAdmin)51686"
          },
          {
            "astId": 4233,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "controller",
            "offset": 0,
            "slot": "2",
            "type": "t_address"
          },
          {
            "astId": 4235,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "finalOwner",
            "offset": 0,
            "slot": "3",
            "type": "t_address"
          }
        ]
      },
      "t_struct(ImplementationAddressConfig)4276_storage": {
        "encoding": "inplace",
        "label": "struct SystemDictator.ImplementationAddressConfig",
        "numberOfBytes": "256",
        "members": [
          {
            "astId": 4254,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l2OutputOracleImpl",
            "offset": 0,
            "slot": "0",
            "type": "t_contract(L2OutputOracle)1233"
          },
          {
            "astId": 4257,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "optimismPortalImpl",
            "offset": 0,
            "slot": "1",
            "type": "t_contract(OptimismPortal)1912"
          },
          {
            "astId": 4260,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l1CrossDomainMessengerImpl",
            "offset": 0,
            "slot": "2",
            "type": "t_contract(L1CrossDomainMessenger)125"
          },
          {
            "astId": 4263,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l1StandardBridgeImpl",
            "offset": 0,
            "slot": "3",
            "type": "t_contract(L1StandardBridge)772"
          },
          {
            "astId": 4266,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "optimismMintableERC20FactoryImpl",
            "offset": 0,
            "slot": "4",
            "type": "t_contract(OptimismMintableERC20Factory)50636"
          },
          {
            "astId": 4269,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l1ERC721BridgeImpl",
            "offset": 0,
            "slot": "5",
            "type": "t_contract(L1ERC721Bridge)325"
          },
          {
            "astId": 4272,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "portalSenderImpl",
            "offset": 0,
            "slot": "6",
            "type": "t_contract(PortalSender)4190"
          },
          {
            "astId": 4275,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "systemConfigImpl",
            "offset": 0,
            "slot": "7",
            "type": "t_contract(SystemConfig)2672"
          }
        ]
      },
      "t_struct(L2OutputOracleDynamicConfig)4281_storage": {
        "encoding": "inplace",
        "label": "struct SystemDictator.L2OutputOracleDynamicConfig",
        "numberOfBytes": "64",
        "members": [
          {
            "astId": 4278,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l2OutputOracleStartingBlockNumber",
            "offset": 0,
            "slot": "0",
            "type": "t_uint256"
          },
          {
            "astId": 4280,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l2OutputOracleStartingTimestamp",
            "offset": 0,
            "slot": "1",
            "type": "t_uint256"
          }
        ]
      },
      "t_struct(ProxyAddressConfig)4251_storage": {
        "encoding": "inplace",
        "label": "struct SystemDictator.ProxyAddressConfig",
        "numberOfBytes": "224",
        "members": [
          {
            "astId": 4238,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l2OutputOracleProxy",
            "offset": 0,
            "slot": "0",
            "type": "t_address"
          },
          {
            "astId": 4240,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "optimismPortalProxy",
            "offset": 0,
            "slot": "1",
            "type": "t_address"
          },
          {
            "astId": 4242,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l1CrossDomainMessengerProxy",
            "offset": 0,
            "slot": "2",
            "type": "t_address"
          },
          {
            "astId": 4244,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l1StandardBridgeProxy",
            "offset": 0,
            "slot": "3",
            "type": "t_address"
          },
          {
            "astId": 4246,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "optimismMintableERC20FactoryProxy",
            "offset": 0,
            "slot": "4",
            "type": "t_address"
          },
          {
            "astId": 4248,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "l1ERC721BridgeProxy",
            "offset": 0,
            "slot": "5",
            "type": "t_address"
          },
          {
            "astId": 4250,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "systemConfigProxy",
            "offset": 0,
            "slot": "6",
            "type": "t_address"
          }
        ]
      },
      "t_struct(ResourceConfig)1945_storage": {
        "encoding": "inplace",
        "label": "struct ResourceMetering.ResourceConfig",
        "numberOfBytes": "32",
        "members": [
          {
            "astId": 1934,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "maxResourceLimit",
            "offset": 0,
            "slot": "0",
            "type": "t_uint32"
          },
          {
            "astId": 1936,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "elasticityMultiplier",
            "offset": 4,
            "slot": "0",
            "type": "t_uint8"
          },
          {
            "astId": 1938,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "baseFeeMaxChangeDenominator",
            "offset": 5,
            "slot": "0",
            "type": "t_uint8"
          },
          {
            "astId": 1940,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "minimumBaseFee",
            "offset": 6,
            "slot": "0",
            "type": "t_uint32"
          },
          {
            "astId": 1942,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "systemTxMaxGas",
            "offset": 10,
            "slot": "0",
            "type": "t_uint32"
          },
          {
            "astId": 1944,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "maximumBaseFee",
            "offset": 14,
            "slot": "0",
            "type": "t_uint128"
          }
        ]
      },
      "t_struct(SystemConfigConfig)4297_storage": {
        "encoding": "inplace",
        "label": "struct SystemDictator.SystemConfigConfig",
        "numberOfBytes": "192",
        "members": [
          {
            "astId": 4283,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "owner",
            "offset": 0,
            "slot": "0",
            "type": "t_address"
          },
          {
            "astId": 4285,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "overhead",
            "offset": 0,
            "slot": "1",
            "type": "t_uint256"
          },
          {
            "astId": 4287,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "scalar",
            "offset": 0,
            "slot": "2",
            "type": "t_uint256"
          },
          {
            "astId": 4289,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "batcherHash",
            "offset": 0,
            "slot": "3",
            "type": "t_bytes32"
          },
          {
            "astId": 4291,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "gasLimit",
            "offset": 0,
            "slot": "4",
            "type": "t_uint64"
          },
          {
            "astId": 4293,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "unsafeBlockSigner",
            "offset": 8,
            "slot": "4",
            "type": "t_address"
          },
          {
            "astId": 4296,
            "contract": "contracts/deployment/SystemDictator.sol:SystemDictator",
            "label": "resourceConfig",
            "offset": 0,
            "slot": "5",
            "type": "t_struct(ResourceConfig)1945_storage"
          }
        ]
      },
      "t_uint128": {
        "encoding": "inplace",
        "label": "uint128",
        "numberOfBytes": "16"
      },
      "t_uint256": {
        "encoding": "inplace",
        "label": "uint256",
        "numberOfBytes": "32"
      },
      "t_uint32": {
        "encoding": "inplace",
        "label": "uint32",
        "numberOfBytes": "4"
      },
      "t_uint64": {
        "encoding": "inplace",
        "label": "uint64",
        "numberOfBytes": "8"
      },
      "t_uint8": {
        "encoding": "inplace",
        "label": "uint8",
        "numberOfBytes": "1"
      }
    }
  }
}